using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace WindowsGame3
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        Texture2D mapChar;                  //LN^eNX`
        int[,] mapInfo = new int[20,15];    //}bvi[

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game content here
            mapChar = Content.Load<Texture2D>("mapchar");         //eNX`Ǎ

            int i = 0;                      //[vpϐ
            int j = 0;                      //[vpϐ
            int intChar = 0;                //}bvL擾p
            Random rand = new Random();     //

            //cSẴ}bvLN^𗐐Őݒ肷
            //
            for (i = 0; i < 20; i++)
            {
                //c
                for (j = 0; j < 15; j++)
                {
                    //𔭐
                    intChar = (int)(float)rand.Next(4);
                    //}bvi[
                    mapInfo[i, j] = intChar;
                }
            }
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);
            int intDrawX = 0;           //`wW
            int intDrawY = 0;           //`xW
            int i = 0;                  //`惋[vp
            int j = 0;                  //`惋[vp
            Rectangle rectPosSrc;       //`W
            Rectangle rectPosDst;       //`挳W
            int intPosX = 0;            //`挳wW

            // TODO: Add your drawing code here
            spriteBatch.Begin(SpriteBlendMode.AlphaBlend);

            //cE[vă}bvL`
            //c
            for (j = 0; j < 15; j++)
            {
                //`xʒuZo
                intDrawY = j * 40;
                //
                for (i = 0; i < 20; i++)
                {
                    //`wʒuZo
                    intDrawX = i * 40;
                    //}bv񂩂A`挳̂wWZo
                    intPosX = mapInfo[i, j] * 40;

                    //`A`挳̍WZo
                    rectPosSrc = new Rectangle(intPosX, 0, 40, 80);
                    rectPosDst = new Rectangle(intDrawX, intDrawY-40, 40, 80);
                    //`
                    spriteBatch.Draw(mapChar, rectPosDst, rectPosSrc, Color.White);
                }
            }
            spriteBatch.End();

            base.Draw(gameTime);
        }
    }
}
